stages:
  - pre-commit
  - schema-check
  - pop-release

include:
  - project: saltstack/pop/cicd/ci-templates
    file: /lint/pre-commit-run-all.yml
  - project: saltstack/pop/cicd/ci-templates
    file: /release/pop_release.yml

pre-commit-run-all:
  image: registry.gitlab.com/saltstack/pop/cicd/containers/alpinelint:py39

variables:
  # TODO If your upstream gitlab url is "gitlab.com/my/upstream/path"
  # Then your CICD_UPSTREAM_PATH would be my/upstream/path"
  # Set this variable for the bot to release this project on Pypi on tag
  CICD_UPSTREAM_PATH: "vmware/idem/idem-resources-validation"

workflow:
  rules:
    - if: $CI_MERGE_REQUEST_ID == null

schema-check-run:
  stage: schema-check
  image: python:3.10.2
  needs:
    - pre-commit-run-all
  script:
    - apt-get update && apt-get install gettext-base
    - mkdir artifacts
    - mkdir repo-dir && cd repo-dir
    - git clone https://gitlab.com/vmware/idem/idem-resources-validation.git
    - cd idem-resources-validation
    - git checkout $CI_COMMIT_SHA
    - export BASE_SCHEMA_VERSION="v5.0.0"
    - export TARGET_SCHEMA_VERSION="HEAD"
    - export VALIDATE_ALL_RESOURCES="True"
    - envsubst < ./tests/plugins/idem-aws.json > ./idem-aws-config.json
    - export PLUGIN_CONFIG_FILE=$(realpath idem-aws-config.json)
    - python3 -m pip install nox
    - nox -e tests-3 -- -vv tests/schema/test_schema_checkers.py
    - mv compatibility-report*.json ../../artifacts
  artifacts:
    paths:
      - artifacts
    expire_in: 3 days
